#include "visidrv.h"
#include <stdio.h>
#include <conio.h>
#include <stdarg.h>
#include <dos.h>




//#define __DISABLE_USE_CRT__
#ifdef __DISABLE_USE_CRT__
int printf(const char *format, ...){};
#endif
//------------------------------------------------------------------------------





unsigned int x,cnt = 0;
unsigned char y;
bool dirx = true;
bool diry = true;
char buf[32]={0};
char buf1[80]={0};

void main()
{


 int i,j;
 bool err;
 FILE* ff;
 printf("\r\nDemo program for LCD display RAIO RA8835\r\n");
 printf("\r\nLibrary version: %x\r\n",GetDrvVersion());
 y = AutosetLPT();if(y == 0) {printf("Can't set LPT! Aborted.\r\n");return;}
 if(!IsDriving()){ printf("Can't drive LCD! Aborted.\r\n");return;}
 if(!LCDInit()){ printf("Can't init LCD! Aborted.\r\n");return;}
 printf("LCD Init done\r\n");
 ClearGraphicsPage();
 ClearTextPage();
 printf("Clear LCD.\r\n");

 Contrast(0x1FF);
 delay(1100);
 Brightness(0x7F);
 delay(1100);
 printf("Load russian font.\r\n");
 if(!LoadFont("c:\FONT.BFF"))
 {
  LCDText(1,29,"Error load russian font! File 'FONT.BFF' \r\n");
  printf("Error load russian font.\r\n");delay(2000);ClearTextPage();
 }
 
 LCDText(0,1," ணࠬ  ஫ RA8835\r\n");
 LCDText(0,29," ⥪- %d\r\n",GetDrvVersion());
 if(!GetTemperature(buf)) {ClearTextPage();LCDText(0,29,"Error get internal temperature!\r\n");}
  else LCDText(32,29,"%sC\r\n",buf);
 delay(3000);
 if(kbhit()) return;
 //for(int n=0;n<0x3FF;n++){Contrast(n);delay(10);}
 //LCDText(0,10,"ணࠬ ॣ㫨஢ \r\n");
 //for(int n=0xFF;n<0x2FF;n++){Contrast(n);delay(20);}
 //delay(1100);
 //Contrast(0x1FF);
 //delay(1000);
 //LCDText(0,11,"ணࠬ ॣ㫨஢ મ\r\n");
 //for(int n=0;n<0xFF;n++){Brightness(n);delay(50);}
 //delay(1000);
 //Brightness(0x7F);
 delay(1000);
 LCDText(0,13,"⮤ 짮⥫\r\n");
 for(int n=0;n<3;n++){UserLed(1);delay(200);UserLed(0);delay(200);}
 LCDText(0,14,"ᢥ⪠ /몫\r\n");
 BrightOnOff(0);delay(500);BrightOnOff(1);delay(500);BrightOnOff(0);delay(500);BrightOnOff(1);delay(500);
 Brightness(0x7F);
 ClearTextPage();

 //----------------------------------------------------------------------------

 //----------------------------------------------------------------------------
 ClearTextPage();
 SetBlink(1,1,1);
 SetCursorSize(0,7,1);
 CurPos(1,1);
 PutString(" ࠢ 뢮 ⥪:");
 printf("Move cursor . . .\r\n");
 LCDText(10,10," ࠢ\r\n");
 delay(1000);
 if(kbhit()) return;
 SetCursorDir(3);
 LCDText(10,10," \r\n");//
 delay(1000);
 if(kbhit()) return;
 SetCursorDir(1);
 LCDText(10,25," \r\n");//
 delay(1000);
 if(kbhit()) return;
 SetCursorDir(2);
 LCDText(10,25," \r\n");//
 delay(1000);
 if(kbhit()) return;
 SetCursorDir(0);
 ClearTextPage();
 printf("Blink text.\r\n");
 SetBlink(1,2,1);
 LCDText(10,15," ⥪⮬\r\n");
 delay(3000);
 if(kbhit()) return;
 SetBlink(0,1,1);
 //----------------------------------------------------------------------------
 err = DrawHorLine(0,0,319);
 if(!err)printf("Error-%d\r\n",GetError());
 err = DrawHorLine(0,239,319);
 if(!err)printf("Error-%d\r\n",GetError());
 err = DrawVerLine(0,0,239);
 if(!err)printf("Error-%d\r\n",GetError());
 err = DrawVerLine(319,0,239);
 if(!err)printf("Error-%d\r\n",GetError());
 //----------------------------------------------------------------------------
  delay(1000);
 ClearGraphicsPage();
 ClearTextPage();
 printf("Overlay.\r\n");
 LCDText(1,20,"Overlay mode demo...\r\n");
 LCDText(1,1,"OR ");
 DrawRect(0,0,32,20);
 SetOverlay(1);LCDText(1,1,"XOR");delay(3000);if(kbhit()) return;
 SetOverlay(2);LCDText(1,1,"AND");delay(3000);if(kbhit()) return;
 SetOverlay(3);LCDText(1,1,"POR");delay(3000);if(kbhit()) return;
 SetOverlay(1);
 delay(1000);
 //----------------------------------------------------------------------------
 ClearGraphicsPage();
 ClearTextPage();
 LCDText(10,10,"Write byte 0xD5 to pos X1,Y2\r\n");
 WriteByteXY(0x0201,0xD5);
 delay(500);
 LCDText(10,11,"Write byte 0xAA to pos X2,Y3\r\n");
 WriteByteXY(0x0302,0xAA);
 delay(1000);
 //----------------------------------------------------------------------------

 ClearGraphicsPage();
 ClearTextPage();
 printf("Scroll.\r\n");
 DrawRect(100,100,10,10);
 LCDText(10,10,"Scroll\r\n");
 for(i=0;i<20;i++){Scroll(i&7);delay(200);}
 if(kbhit()) return;
 delay(1000);
 ClearGraphicsPage();
 ClearTextPage();
 printf("Draw lines.\r\n");
 for(i=0;i<240;i+=4)
  {
   DrawHorLine(0,i,i+1);
  }
 //----------------------------------------------------------------------------
 delay(3000);
 if(kbhit()) return;
 for(j=0;j<240;j+=4)
 {
  DrawVerLine(j,0,j+1);
 }
 //----------------------------------------------------------------------------
 delay(3000);
 if(kbhit()) return;
 ClearGraphicsPage();
 ClearTextPage();
 for(i=0;i<240;i+=4)
  {
   DrawHorLine(i,i,10);
  }
 //----------------------------------------------------------------------------
 delay(3000);
 if(kbhit()) return;
 for(j=0;j<240;j+=4)
 {
  DrawVerLine(j,j,10);
 }
//----------------------------------------------------------------------------
 delay(3000);
 if(kbhit()) return;
 ClearGraphicsPage();
 for(i=0;i<240;i+=1)
  {
   DrawHorLine(0,i,i+1);
  }
//----------------------------------------------------------------------------
 delay(3000);
 if(kbhit()) return;
 for(j=0;j<240;j+=1)
 {
  DrawVerLine(j,0,j+1);
 }
//----------------------------------------------------------------------------
 delay(3000);
 ClearGraphicsPage();
 for(i=0;i<240;i+=4)
  {
   DrawHorLine(0,i,319);
  }
//----------------------------------------------------------------------------
 delay(3000);
 if(kbhit()) return;
 for(j=0;j<320;j+=4)
 {
  DrawVerLine(j,0,239);
 }
//----------------------------------------------------------------------------
 delay(3000);
 printf("Load image.\r\n");
 ClearGraphicsPage();
 ClearTextPage();
 LCDText(10,11,"Load Image. Filename '1'\r\n");
unsigned char imarr[9600];
ff =  fopen("1","r");
 if(ff == NULL)
  {
   printf("Error load image '1'!\r\n");
   LCDText(1,29,"Error load image '1'!\r\n");
   delay(1000);ClearTextPage();goto err_load_im;}
 fread(imarr,9600,1,ff);
 LoadArray(imarr);
 err_load_im:
 //----------------------------------------------------------------------------

 delay(3000);
 if(kbhit()) return;
 ClearGraphicsPage();
 ClearTextPage();
 printf("Set pixels...\r\n");

 for(x=0;x<320;x++)
  {
    y = x/2;
    SetPix(x,y);
    delay(15);
  }

 //----------------------------------------------------------------------------
delay(3000);
if(kbhit()) return;
 ClearGraphicsPage();
 ClearTextPage();
 printf("Moving rectangle...\r\n");

 x = 0;y = 0;cnt = 0;
 while(1)
 {
   if(kbhit()) return;
   if(x+10 >= 319) dirx = false;
   if(x ==0) dirx = true;
   if(y+10 >= 239) diry = false;
   if(y ==0) diry = true;
   DrawRect(x,y,10,10);
   delay(5);
   ClearRect(x,y,10,10);
   if(dirx) x++;else x--;
   if(diry) y++;else y--;
   if((cnt++) > 1000)break;
 }
 LCDText(1,29,"Have a nice day :-)\r\n");
 delay(1000);
 DispONOFF(0);
 printf("Good bay.\r\n");

}//main
